package com.ejie.ab79.model.protocolos;

import java.util.Date;

import com.ejie.ab79.model.inspecciones.OrigenesInspeccion;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.ab79.model.procedimientos.Procedimientos;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * Protocolos  
 * 
 *  
 */

public class Protocolos implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idProtocolo;
	private Direcciones direccion;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private String tipoEstablecimiento;
	private String categoriaEstablecimiento;
	private String modalidadEstablecimiento;
	private Integer numeroPreguntas;
	private Integer numeroRespuestas;
	private Integer numeroInspecciones;
	private OrigenesInspeccion origen;
	private Procedimientos procedimiento;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private Integer validado;

	/**
	 * Method 'Protocolos'.
	 */
	public Protocolos() {
	}

	/**
	 * Method 'Protocolos'.
	 * 
	 * @param idProtocolo
	 *            Integer
	 */
	public Protocolos(Integer idProtocolo) {
		this.idProtocolo = idProtocolo;
	}

	/**
	 * Method 'Protocolos'.
	 * 
	 * @param idProtocolo
	 *            Integer
	 * @param idDireccion
	 *            Integer
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public Protocolos(Integer idProtocolo, Direcciones direccion, String descripcionCastellano, String descripcionEuskera,
			Date fechaRegistro, String usuarioRegistro, String categoriaEstablecimiento, String tipoEstablecimiento,
			String modalidadEstablecimiento) {

		this.idProtocolo = idProtocolo;
		this.direccion = direccion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.categoriaEstablecimiento = categoriaEstablecimiento;
		this.tipoEstablecimiento = tipoEstablecimiento;
		this.modalidadEstablecimiento = modalidadEstablecimiento;
	}

	/**
	 * Method 'getIdProtocolo'.
	 *
	 * @return Integer
	 */

	public Integer getIdProtocolo() {
		return this.idProtocolo;
	}

	/**
	 * Method 'setIdProtocolo'.
	 *
	 * @param idProtocolo
	 *            Integer
	 * @return
	 */

	public void setIdProtocolo(Integer idProtocolo) {
		this.idProtocolo = idProtocolo;
	}

	/**
	 * Method 'getDireccion'.
	 *
	 * @return Direcciones
	 */

	public Direcciones getDireccion() {
		return this.direccion;
	}

	/**
	 * Method 'setDireccion'.
	 *
	 * @param direccion
	 *            Direcciones
	 * @return
	 */

	public void setDireccion(Direcciones direccion) {
		this.direccion = direccion;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */

	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */

	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}
	
	/**
	 * Method 'getTipoEstablecimiento'.
	 * 
	 * @return String
	 */
	
	public String getTipoEstablecimiento() {
		return tipoEstablecimiento;
	}
	
	/**
	 * Method 'setTipoEstablecimiento'.
	 * 
	 * @param tipoEstablecimiento
	 * 			  String
	 * @return
	 */
	
	public void setTipoEstablecimiento(String tipoEstablecimiento) {
		this.tipoEstablecimiento = tipoEstablecimiento;
	}
	
	/**
	 * Method 'getCategoriaEstablecimiento'.
	 * 
	 * @return String
	 */
	
	public String getCategoriaEstablecimiento() {
		return categoriaEstablecimiento;
	}
	
	/**
	 * Method 'setCategoriaEstablecimiento'.
	 * 
	 * @param categoriaEstablecimiento
	 * 			  String
	 * @return
	 */
	
	public void setCategoriaEstablecimiento(String categoriaEstablecimiento) {
		this.categoriaEstablecimiento = categoriaEstablecimiento;
	}
	
	/**
	 * Method 'getModalidadEstablecimiento'.
	 * 
	 * @return String
	 */
	
	public String getModalidadEstablecimiento() {
		return modalidadEstablecimiento;
	}
	
	/**
	 * Method 'setModalidadEstablecimiento'.
	 * 
	 * @param modalidadEstablecimiento
	 * 			  String
	 * @return
	 */
	
	public void setModalidadEstablecimiento(String modalidadEstablecimiento) {
		this.modalidadEstablecimiento = modalidadEstablecimiento;
	}
	
	/**
	 * Method 'getNumeroPreguntas'.
	 * 
	 * @return Integer
	 */
	
	public Integer getNumeroPreguntas() {
		return numeroPreguntas;
	}
	
	/**
	 * Method 'setNumeroPreguntas'.
	 * 
	 * @param numeroPreguntas
	 * 			  Integer
	 * @return
	 */
	
	public void setNumeroPreguntas(Integer numeroPreguntas) {
		this.numeroPreguntas = numeroPreguntas;
	}
	
	/**
	 * Method 'getNumeroRespuestas'
	 * 
	 * @return Integer
	 */
	
	public Integer getNumeroRespuestas() {
		return this.numeroRespuestas;
	}
	
	/**
	 * Method 'setNumeroRespuestas'
	 * 
	 * @param numeroRespuestas
	 * 			  Integer
	 * @return
	 */
	
	public void setNumeroRespuestas(Integer numeroRespuestas) {
		this.numeroRespuestas = numeroRespuestas;
	}
	
	public Integer getNumeroInspecciones() {
		return numeroInspecciones;
	}

	public void setNumeroInspecciones(Integer numeroInspecciones) {
		this.numeroInspecciones = numeroInspecciones;
	}

	/**
	 * Method 'getOrigen'
	 * 
	 * @return OrigenesInspeccion
	 */
	
	public OrigenesInspeccion getOrigen() {
		return origen;
	}
	
	/**
	 * Method 'setOrigen'
	 * 
	 * @param origen
	 * 			  OrigenesInspeccion
	 * @return
	 */
	
	public void setOrigen(OrigenesInspeccion origen) {
		this.origen = origen;
	}
	
	/**
	 * Method 'getProcedimiento'
	 * 
	 * @return Procedimientos
	 */
	
	public Procedimientos getProcedimiento() {
		return procedimiento;
	}
	
	/**
	 * Method 'setProcedimiento' 
	 * 
	 * @param procedimiento
	 * 			  Procedimientos
	 * @return
	 */
	
	public void setProcedimiento(Procedimientos procedimiento){
		this.procedimiento = procedimiento;
	}
	
	/**
	 * Method 'getFechaUltmodificacion'
	 * 
	 * @return Date
	 */
	
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return fechaUltmodificacion;
	}
	
	/**
	 * Method 'setFechaUltmodificacion'
	 * 
	 * @param fechaUltmodificacion
	 * 			  Date
	 * @return
	 */
	
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}
	
	/**
	 * Method 'getUsuarioUltmodificacion' 
	 * 
	 * @return String
	 */
	
	public String getUsuarioUltmodificacion() {
		return usuarioUltmodificacion;
	}
	
	/**
	 * Method 'setUsuarioUltmodificacion'
	 * 
	 * @param usuarioUltmodificacion
	 * 			  String
	 * @return
	 */
	
	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}
	
	/**
	 * Method 'getValidado'
	 * 
	 * @return Integer
	 */
	
	public Integer getValidado() {
		return validado;
	}
	
	/**
	 * Method 'setValidado'
	 *  
	 * @param validado
	 * 			  Integer
	 * @return
	 */
	
	public void setValidado(Integer validado) {
		this.validado = validado;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idProtocolo: ").append(this.idProtocolo).append(" ]");
		result.append(", [ direccion: ").append(this.direccion).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ numeroPreguntas: ").append(this.numeroPreguntas).append(" ]");
		result.append("}");
		return result.toString();
	}

}
